/*** KEY.H ***/

/* Written By P.A. McKenzie
 * The C Window Library
 * Copyright (C) 1990   All Rights Reserved
*/
#ifndef KEY_DEF
#define KEY_DEF
#if defined (GLOBAL_DEF)
#define EXTERN
#else
#define EXTERN extern
#endif
#include "keycodes.h"

#define FLUSH_KEYBOARD()       flush_keyboard(enhanced_keyboard?17:1)
#define ISKEYREADY()           key_ready(enhanced_keyboard?17:1)
#define GET_SHIFT_STATE()      bioskbd(2)
#define GET_KEY()              getkeyfunc(0)
#define GET_ENHANCED_KEY()     getkeyfunc(1)
#define ENHANCED_KEYBOARD()    (enhanced_keyboard?1:0)

#define OVERSTRIKEMODE      0
#define INSERTMODE          1

#define KEYPRESSED          0
#define MOUSEPRESSED        1


#define UPPERCASE                1
#define LOWERCASE                2
#define CHECKSPACES              4
#define ENHANCEDKEY              8
#define CHECKREGEXP             16
#define AUTORETURN              32
#define CHECKREGEXP_IGNORECASE  64
#define FLUSHBUFFER            128
#define FORMFLAG               256
#define HOMECURSOR             512
#define USEMOUSE              1024
#define CLEARFIELD            2048
#define VIRTUALFIELD          4096

#define DONT_PROCESS        0
#define MOVE_CURSOR_LEFT    1
#define MOVE_CURSOR_RIGHT   2
#define DELETE_AT_CURSOR    3
#define TOGGLE_INSERT       4
#define DESTRUCT_BACKSPACE  5
#define ACCEPT_INPUT        6
#define ACCEPT_DEFAULT      7
#define ERASE_INPUT         8
#define GOTO_FIRST          9
#define GOTO_LAST          10
#define INSERT_CHARACTER   11
#define MOVE_TO_CHARACTER  12
#define GOTO_NEXT_FIELD    13
#define GOTO_PREV_FIELD    14
#define EXIT_FORM_ACCEPT   15
#define EXIT_FORM_CLEAR    16
#define CLEAR_FORM         17

#define MOVELEFT_KEY        0
#define MOVERIGHT_KEY       1
#define DELNOMOVE_KEY       2
#define INSTOGGLE_KEY       3
#define ERASE_KEY           4
#define BACKSPACE_KEY       5
#define ACCEPT_KEY          6
#define ACCEPTDEFAULT_KEY   7
#define HOME_KEY            8
#define END_KEY             9

/********************************************
 * Key locations in the form_edit_key array *
 ********************************************/

#define FIELD_MOVELEFT_KEY         MOVELEFT_KEY
#define FIELD_MOVERIGHT_KEY        MOVERIGHT_KEY
#define FIELD_DELNOMOVE_KEY        DELNOMOVE_KEY
#define FIELD_INSTOGGLE_KEY        INSTOGGLE_KEY
#define FIELD_ERASE_KEY            ERASE_KEY
#define FIELD_BACKSPACE_KEY        BACKSPACE_KEY
#define FIELD_ACCEPT_KEY           ACCEPT_KEY
#define FIELD_ACCEPTDEFAULT_KEY    ACCEPTDEFAULT_KEY
#define FIELD_HOME_KEY             HOME_KEY
#define FIELD_END_KEY              END_KEY
#define FIELD_PREVFIELD_KEY        10
#define FIELD_NEXTFIELD_KEY        11
#define FORM_EXIT_ACCEPT_KEY       12
#define FORM_EXIT_CLEAR_KEY        13
#define FORM_CLEAR_KEY             14
#define FORM_LFORWARD_KEY          15
#define FORM_LBACKWARD_KEY         16




#define FIELD_CONTINUE         DONT_PROCESS
#define FIELD_MOVELEFT         MOVE_CURSOR_LEFT
#define FIELD_MOVERIGHT        MOVE_CURSOR_RIGHT
#define FIELD_DELNOMOVE        DELETE_AT_CURSOR
#define FIELD_INSTOGGLE        TOGGLE_INSERT
#define FIELD_BACKSPACE        DESTRUCT_BACKSPACE
#define FIELD_ACCEPT           ACCEPT_INPUT
#define FIELD_ACCEPTDEFAULT    ACCEPT_DEFAULT
#define FIELD_ERASEINPUT       ERASE_INPUT
#define FIELD_GOTOFIRST        GOTO_FIRST
#define FIELD_GOTOLAST         GOTO_LAST
#define FIELD_INSERTCHAR       INSERT_CHARACTER
#define FIELD_MOVE_TO_CHARACTER MOVE_TO_CHARACTER
#define FIELD_NEXTFIELD        GOTO_NEXT_FIELD
#define FIELD_PREVFIELD        GOTO_PREV_FIELD
#define FORM_ACCEPT            EXIT_FORM_ACCEPT
#define FORM_EXIT_CLEAR        EXIT_FORM_CLEAR
#define FORM_CLEAR             CLEAR_FORM


#define FORM_END                18
#define FIELD_REEDIT            19
#define FIELD_NEWFIELD          20
#define FIELD_PROCESS_DATA      21
#define FIELD_CONTINUE_PROCESS  22
#define FORM_REEDIT             23
#define FIELD_EDIT              24
EXTERN int default_cursor_type[2];
EXTERN int default_cursor_mode;
EXTERN int enhanced_keyboard;
EXTERN unsigned int last_key_hit;
EXTERN int (*undef_fkey_func)(char *,int,int,int *);
EXTERN int (*undef_akey_func)(char *,int,int,int *);

EXTERN int (*num_chars_entered_func)(char *,int);
EXTERN int (*reg_exp_error_func)(char *, int);
EXTERN int (*process_field_error_func)(int, char *, int, int);
EXTERN int (*do_undef_form_func_ptr)(char *, int, int *, int);
EXTERN void     (*key_idle_func)(void);
EXTERN unsigned (*key_intercept_func)(int,unsigned);
EXTERN int field_button_press;
EXTERN int form_action_key;
EXTERN int flush_keyboard_flag;

#if __cplusplus
   extern "C" {
#endif

unsigned bioskbd(int);
int GetEnhancedKeyboard (void);
unsigned getkeyfunc(int);
int key_ready(int);
void flush_keyboard(int);
unsigned process_keyval(int);

#if __cplusplus
   }
#endif

#endif
